// THIS FILE IS AUTOMATICALLY GENERATED
// Add your code only between //--cg--xxxx-begin and //--cg--xxxx-end

//---------------------------------------------------------------------------
#pragma hdrstop
//#pragma package(smart_init)

#if _WIN32
#include <windows.h>
#include "sqlite3.h"
#include <list>				// standard list template class
using namespace std;		// windows needs this to instantiate the list class
#endif


#include <stdio.h>
#include "stack.h"
#include "requestHandler.h"
#define FREE_Str(s) sqlite3_free(s)

//--cg--sqlite--begin

//  include files and declarations here
#include "sqlite3.h"
#include "methodName.h"
#include "threads.h"

// there is mutual exclusion for db access (sqlite_step).
TMutex sqliteMutex;
int    threadsIn = 0;
int    threadsWait = 0;
//--cg--sqlite--end

//---------------------------------------------------------------------------


PointerHolder* RequestHandler::getHolderByHandle(list<PointerHolder*> &v, int handle)
{
  list<PointerHolder*>::const_iterator iter;
  PointerHolder* ph = 0;
  for(iter=v.begin();iter != v.end();iter++)
  {
     ph = (*iter);
     if (ph->getHandle()==handle) return ph;
  }
  return ph;
}

 RequestHandler::RequestHandler()
 {
   handlecounter = 0;
 }

 RequestHandler::~RequestHandler()
 {

  list<PointerHolder*>::const_iterator iter;
  PointerHolder* ph = 0;

  for(iter=vmhandles.begin();iter != vmhandles.end();iter++)
  {
     ph = (*iter);
     sqlite3_finalize((sqlite3_stmt*)ph->getPointer());
     delete ph;
  }

  for(iter=dbhandles.begin();iter != dbhandles.end();iter++)
  {
     ph = (*iter);
     sqlite3_close((sqlite3*)ph->getPointer());
     delete ph;
  }

 }

//------------------------ svc methods -------------------------


int RequestHandler::svc_sqlite_open(
                  STACK_Str in_filename ,
                  STACK_Int *out_errcode ,
                  STACK_Str *out_errmsg ,
                  STACK_Int *out_db_handle 
             )
{
//--cg--sqlite/methods/sqlite_open--begin
 // implement this method
 try
 {
   sqlite3* db=NULL;
   int ok = sqlite3_open(in_filename,&db);
   if (ok == SQLITE_OK)
   {
    PointerHolder* ph = new PointerHolder(db,handlecounter++);
    dbhandles.push_back(ph);
    (*out_db_handle) = ph->getHandle();
    (*out_errcode)   = SQLITE_OK;
     // printf("DB Handle created: Pool Size=%d\n",dbhandles.size());
   }
   else
   {
     (*out_errcode)  = SQLITE_ERROR;
   }
 }
 catch(...)
 {
  return STACK_SERVER_STUB_ERROR;
 }
 return STACK_OK;
//--cg--sqlite/methods/sqlite_open--end

}	


int RequestHandler::svc_sqlite_close(
                  STACK_Int in_db_handle ,
				  STACK_Int *out_errorcode
             )
{
//--cg--sqlite/methods/sqlite_close--begin
 // implement this method
 PointerHolder *ph = getHolderByHandle(dbhandles,in_db_handle);
 if (ph != 0)
 {
  sqlite3* db = (sqlite3*)ph->getPointer();
  *out_errorcode = sqlite3_close(db);
  dbhandles.remove(ph);
  delete ph;
  //printf("DB Handle released: Pool Size=%d\n",dbhandles.size());
  return STACK_OK;
 }
 else
  return STACK_USER_ERROR_BASE+BAD_HANDLE;
//--cg--sqlite/methods/sqlite_close--end

}	


int RequestHandler::svc_sqlite_compile(
                  STACK_Int in_db_handle ,
                  STACK_Str in_sql ,  
                  STACK_Int *out_tailIndex ,
                  STACK_Int *out_vm_handle ,
                  STACK_Int *out_errcode ,
                  STACK_Str *out_errmsg 
             )
{
//--cg--sqlite/methods/sqlite_compile--begin
 // implement this method
 PointerHolder *ph = getHolderByHandle(dbhandles,in_db_handle);
 if (ph != 0)
 {
   sqlite3* db = (sqlite3*)ph->getPointer();
   char* out_tail;

   sqlite3_stmt* vm;
	  (*out_errcode) = sqlite3_prepare(db,in_sql,strlen(in_sql),&vm,(const char **)&out_tail);

#ifdef _DEBUG
	  //DEBUG:
	  { char temp[64];
	    int i;
	    strncpy((char *)temp,in_sql,sizeof(temp));
		//SANITIZE THE SQL BUFFER
		for(i=0; (i<sizeof(temp))&&(temp[i]>0);i++) 
			{ if((temp[i]<' ')||(temp[i]>=128))
				{ 
				temp[i]='.';
			}
			}
		if((strlen(temp)+4)>sizeof(temp)) { strcpy(temp+sizeof(temp)-4,"..."); }
        printf("in_sql : %s...\n",temp);
	  }
		//      printf("in_sql length : %d\n",(int)st(in_sql));
		printf("out_tail : %s\n",out_tail);
        (*out_tailIndex) = (unsigned int)(out_tail) - (unsigned int)in_sql + 1;
        printf("return tail index %d\n",*out_tailIndex);
#endif

   if ((*out_errcode) == SQLITE_OK)
   {
     PointerHolder *ph = new PointerHolder(vm,handlecounter++);
     vmhandles.push_back(ph);
     (*out_vm_handle) = ph->getHandle();
      //printf("VM Handle created: Pool Size=%d\n",vmhandles.size());
   }

  return STACK_OK;
 }
 else
  return STACK_USER_ERROR_BASE+BAD_HANDLE;

//--cg--sqlite/methods/sqlite_compile--end

}	

//
// sqlite3 version of query step.  This is substantially modified
// from the sqlite2 version, because sqlite3 doesn't automatically
// create an array of the current values and names.  Instead of
// creating STACK_Array of the results, we pass back the essential
// information and let them be streamed out.  This also leaves open
// the possibility of variations on sqlite_step to handle blobs
// effeciently, or to skip passing back the column names every time.
//
int RequestHandler::svc_sqlite_step_server(
                  STACK_Int in_vm_handle ,		// statement handle
				  STACK_Int	*out_nvalues ,		// return the number of columns
				  STACK_Int *out_errcode,		// return the sqlite error code
				  void **out_vm)				// return the internal statement struture
{
//--cg--sqlite/methods/sqlite_step--begin
 // implement this method
 PointerHolder *ph = getHolderByHandle(vmhandles,in_vm_handle);
 if (ph != 0)
 {
   sqlite3_stmt* vm = (sqlite3_stmt*)ph->getPointer();
   *out_vm = vm;
   sqliteMutex.lock();
    (*out_errcode) = sqlite3_step(vm);
   sqliteMutex.unlock();
   if (*out_errcode == SQLITE_ROW)
   { *out_nvalues = sqlite3_column_count(vm);
   }
   else
   if (*out_errcode == SQLITE_DONE)
   { *out_nvalues = 0;
   }
   else 
   if (*out_errcode == SQLITE_BUSY)
   {
     printf("SQLITE IS BUSY\n");
   }

  return STACK_OK;
 }
 else
  return STACK_USER_ERROR_BASE+BAD_HANDLE;
//--cg--sqlite/methods/sqlite_step--end

}	


int RequestHandler::svc_sqlite_finalize(
                  STACK_Int in_vm_handle ,  
                  STACK_Int *out_errcode ,
                  STACK_Str *out_errmsg 
             )
{
//--cg--sqlite/methods/sqlite_finalize--begin

 PointerHolder *ph = getHolderByHandle(vmhandles,in_vm_handle);
 if (ph != 0)
 {
   sqlite3_stmt* vm = (sqlite3_stmt*)ph->getPointer();
   (*out_errmsg)  = 0;
   (*out_errcode) = sqlite3_finalize(vm);
   if((out_errmsg!=NULL) && (*out_errcode!=SQLITE_OK))
	{ const char *msg = sqlite3_errmsg(sqlite3_db_handle(vm));;
	  *out_errmsg = (char *)msg;
	};
   vmhandles.remove(ph);
   delete ph;
   //printf("VM Handle released: Pool Size=%d\n",vmhandles.size());
   return STACK_OK;
 }
 else
  return STACK_USER_ERROR_BASE+BAD_HANDLE;

//--cg--sqlite/methods/sqlite_finalize--end

}	


int RequestHandler::svc_sqlite_reset(
                  STACK_Int in_vm_handle ,  
                  STACK_Int *out_errcode ,
                  STACK_Str *out_errmsg 
             )
{
//--cg--sqlite/methods/sqlite_reset--begin

 PointerHolder *ph = getHolderByHandle(vmhandles,in_vm_handle);
 if (ph != 0)
 {
   sqlite3_stmt* vm = (sqlite3_stmt*)ph->getPointer();
   (*out_errcode) = sqlite3_reset(vm);
   if((out_errmsg!=NULL) && (*out_errcode!=SQLITE_OK))
	{ const char *msg = sqlite3_errmsg(sqlite3_db_handle(vm));;
	  *out_errmsg = (char *)msg;
	};
   return STACK_OK;
 }
 else
  return STACK_USER_ERROR_BASE+BAD_HANDLE;
//--cg--sqlite/methods/sqlite_reset--end

}	


int RequestHandler::svc_sqlite_changes(
                  STACK_Int in_db_handle 
                 ,  
                  STACK_Int *out_count 
             )
{
//--cg--sqlite/methods/sqlite_changes--begin

 PointerHolder *ph = getHolderByHandle(dbhandles,in_db_handle);
 if (ph != 0)
 {
   sqlite3* db = (sqlite3*)ph->getPointer();
   (*out_count) = sqlite3_changes(db);
   return STACK_OK;
 }
 else
  return STACK_USER_ERROR_BASE+BAD_HANDLE;
//--cg--sqlite/methods/sqlite_changes--end

}	


int RequestHandler::svc_sqlite_last_insert_rowid(
                  STACK_Int in_db_handle 
                 ,  
                  STACK_Int *out_rowid 
             )
{
//--cg--sqlite/methods/sqlite_last_insert_rowid--begin
 PointerHolder *ph = getHolderByHandle(dbhandles,in_db_handle);
 if (ph != 0)
 {
   sqlite3* db = (sqlite3*)ph->getPointer();
   (*out_rowid) = sqlite3_last_insert_rowid(db);
   return STACK_OK;
 }
 else
  return STACK_USER_ERROR_BASE+BAD_HANDLE;
//--cg--sqlite/methods/sqlite_last_insert_rowid--end

}	


int RequestHandler::svc_sqlite_interrupt(
                  STACK_Int in_db_handle 
             )
{
//--cg--sqlite/methods/sqlite_interrupt--begin
 PointerHolder *ph = getHolderByHandle(dbhandles,in_db_handle);
 if (ph != 0)
 {
   sqlite3* db = (sqlite3*)ph->getPointer();
   sqlite3_interrupt(db);
   return STACK_OK;
 }
 else
  return STACK_USER_ERROR_BASE+BAD_HANDLE;
//--cg--sqlite/methods/sqlite_interrupt--end

}	


int RequestHandler::svc_sqlite_libversion(
                   
                  STACK_Str *out_version 
             )
{
//--cg--sqlite/methods/sqlite_libversion--begin
 (*out_version) = (char*)sqlite3_libversion();
 return STACK_OK;
//--cg--sqlite/methods/sqlite_libversion--end

}	

#if 0
int RequestHandler::svc_sqlite_libencoding(
                   
                  STACK_Str *out_encoding 
             )
{
//--cg--sqlite/methods/sqlite_libencoding--begin
 (*out_encoding) = (char*)sqlite3_libencoding();
 return STACK_OK;	
//--cg--sqlite/methods/sqlite_libencoding--end

}	
#endif

//! automatically generated method (from methods.def)
int RequestHandler::handleRequest(int new_socket, SktStack *stack)
{
    int res = stack->recvMessage(new_socket);
    if (res == STACK_OK)
    {
      char Method = stack->readByte();
      try
      {
          switch (MethodName(Method))
          {
            case METHOD_None:
                 {
#ifdef _DEBUG
				printf("Net: Noop\n");
#endif
                   stack->reset();
                   stack->writeInt(STACK_OK);
                 }
                 break;
            case METHOD_sqlite_open:
               {
#ifdef _DEBUG
				printf("Net: Open ");
#endif
                   // read input parameters
                    STACK_Str in_filename = stack->readStr();
 
                    //defining output parameters
                    STACK_Int out_errcode=SQLITE_INTERNAL;
                    STACK_Str out_errmsg=NULL;
                    STACK_Int out_db_handle=0;

                    // call method
                    int res = svc_sqlite_open(
                      in_filename ,
                      &out_errcode ,
                      &out_errmsg ,
                      &out_db_handle 
                    );

                    // reset stack
                    stack->reset();

                    //write server result
                    stack->writeInt(res);

                    // write back output parameters
                    if (res == STACK_OK)
                    {
                       stack->writeInt(out_errcode);
                       stack->writeStr(out_errmsg);
                       //freeing because this param is realloced
                       FREE_Str(out_errmsg);
                       stack->writeInt(out_db_handle);
                    } 	 
#ifdef _DEBUG
				printf("\n");
#endif

               } // end of case METHOD_sqlite_open:
               break;
            case METHOD_sqlite_close:
               {
#ifdef _DEBUG
				printf("Net: Close ");
#endif
                    // read input parameters
                    STACK_Int in_db_handle = stack->readInt();
					STACK_Int out_errorcode;

                    // call method
                    int res = svc_sqlite_close(
                      in_db_handle ,
					  &out_errorcode
                    );

                    // reset stack
                    stack->reset();

                    //write server result
                    stack->writeInt(res);
					if (res == STACK_OK)
					{
					stack->writeInt(out_errorcode);
					}

#ifdef _DEBUG
				printf("\n");
#endif
              } // end of case METHOD_sqlite_close:
               break;
            case METHOD_sqlite_compile:
               {
#ifdef _DEBUG
				printf("Net: Compile ");
#endif
                    // read input parameters
                    STACK_Int in_db_handle = stack->readInt();
                    STACK_Str in_sql = stack->readStr();

                    //defining output parameters
                    STACK_Int out_tailIndex=0;
                    STACK_Int out_vm_handle=0;
                    STACK_Int out_errcode=SQLITE_INTERNAL;
                    STACK_Str out_errmsg=NULL;

                    // call method
                    int res = svc_sqlite_compile(
                      in_db_handle ,
                      in_sql 
                     ,  
                      &out_tailIndex ,
                      &out_vm_handle ,
                      &out_errcode ,
                      &out_errmsg 
                    );

                    // reset stack
                    stack->reset();

                    //write server result
                    stack->writeInt(res);

                    // write back output parameters
                    if (res == STACK_OK)
                    {
                       stack->writeInt(out_tailIndex);
                       stack->writeInt(out_vm_handle);
                       stack->writeInt(out_errcode);
                       stack->writeStr(out_errmsg);
                       //freeing because this param is realloced
                       FREE_Str(out_errmsg);
                    } 	 
#ifdef _DEBUG
				printf("\n");
#endif
              } // end of case METHOD_sqlite_compile:
               break;
            case METHOD_sqlite_step:
               {
#ifdef _DEBUG
				printf("Net: Step ");
#endif
                   // read input parameters
                    STACK_Int in_vm_handle = stack->readInt();
					STACK_Int out_nValues;
                    //defining output parameters
                    STACK_Int out_errcode=SQLITE_INTERNAL;
					sqlite3_stmt *vm=NULL;
                    // call method
                   int res = svc_sqlite_step_server(
                      in_vm_handle , 
					  &out_nValues,
					  &out_errcode,
					  (void **)&vm
                    );

                    // reset stack
                    stack->reset();

                    //write server result
                    stack->writeInt(res);

                    // write back output parameters,
                    if (res == STACK_OK)
                    {  
					   int i;
                       stack->writeInt(out_errcode);	// sqlite error code 

					   // this writes an array in the same format as writeStrArray
                       stack->writeInt(out_nValues);	// column values
					   for(i=0;i<out_nValues;i++)
					   {	STACK_Str val = (char *)sqlite3_column_text(vm,i);
							stack->writeStr(val);
					   }

  					   // this writes an array in the same format as writeStrArray
                      stack->writeInt(out_nValues);	// column names
					   for(i=0;i<out_nValues;i++)
					   {	STACK_Str val = (char *)sqlite3_column_name(vm,i);
							stack->writeStr(val);
					   }
                    } 	 
#ifdef _DEBUG
				printf("\n");
#endif
               } // end of case METHOD_sqlite_step:
               break;
            case METHOD_sqlite_finalize:
               {
#ifdef _DEBUG
				printf("Net: Finalize ");
#endif
                    // read input parameters
                    STACK_Int in_vm_handle = stack->readInt();

                    //defining output parameters
                    STACK_Int out_errcode=SQLITE_INTERNAL;
                    STACK_Str out_errmsg=NULL;

                    // call method
                    int res = svc_sqlite_finalize(
                      in_vm_handle 
                     ,  
                      &out_errcode ,
                      &out_errmsg 
                    );

                    // reset stack
                    stack->reset();

                    //write server result
                    stack->writeInt(res);

                    // write back output parameters
                    if (res == STACK_OK)
                    {
                       stack->writeInt(out_errcode);
                       stack->writeStr(out_errmsg);
                       //freeing because this param is realloced
                       FREE_Str(out_errmsg);
                    } 	 
#ifdef _DEBUG
				printf("\n");
#endif
               } // end of case METHOD_sqlite_finalize:
               break;
            case METHOD_sqlite_reset:
               {
                    // read input parameters
#ifdef _DEBUG
				printf("Net: Reset ");
#endif
                    STACK_Int in_vm_handle = stack->readInt();

                    //defining output parameters
                    STACK_Int out_errcode=SQLITE_INTERNAL;
                    STACK_Str out_errmsg=NULL;

                    // call method
                    int res = svc_sqlite_reset(
                      in_vm_handle 
                     ,  
                      &out_errcode ,
                      &out_errmsg 
                    );

                    // reset stack
                    stack->reset();

                    //write server result
                    stack->writeInt(res);

                    // write back output parameters
                    if (res == STACK_OK)
                    {
                       stack->writeInt(out_errcode);
                       stack->writeStr(out_errmsg);
                       //freeing because this param is realloced
                       FREE_Str(out_errmsg);
                    } 	 
#ifdef _DEBUG
				printf("\n");
#endif
              } // end of case METHOD_sqlite_reset:
               break;
            case METHOD_sqlite_changes:
               {
                    // read input parameters
#ifdef _DEBUG
				printf("Net: Changes ");
#endif
                   STACK_Int in_db_handle = stack->readInt();

                    //defining output parameters
                    STACK_Int out_count;

                    // call method
                    int res = svc_sqlite_changes(
                      in_db_handle 
                     ,  
                      &out_count 
                    );

                    // reset stack
                    stack->reset();

                    //write server result
                    stack->writeInt(res);

                    // write back output parameters
                    if (res == STACK_OK)
                    {
                       stack->writeInt(out_count);
                    } 	 
#ifdef _DEBUG
				printf("\n");
#endif
              } // end of case METHOD_sqlite_changes:
               break;
            case METHOD_sqlite_last_insert_rowid:
               {
                    // read input parameters
#ifdef _DEBUG
				printf("Net: Last Rowid ");
#endif
                    STACK_Int in_db_handle = stack->readInt();

                    //defining output parameters
                    STACK_Int out_rowid;

                    // call method
                    int res = svc_sqlite_last_insert_rowid(
                      in_db_handle 
                     ,  
                      &out_rowid 
                    );

                    // reset stack
                    stack->reset();

                    //write server result
                    stack->writeInt(res);

                    // write back output parameters
                    if (res == STACK_OK)
                    {
                       stack->writeInt(out_rowid);
                    } 	 
#ifdef _DEBUG
				printf("\n");
#endif
              } // end of case METHOD_sqlite_last_insert_rowid:
               break;
            case METHOD_sqlite_interrupt:
               {
                    // read input parameters
#ifdef _DEBUG
				printf("Net: Interrupt ");
#endif
                    STACK_Int in_db_handle = stack->readInt();


                    // call method
                    int res = svc_sqlite_interrupt(
                      in_db_handle 
                    );

                    // reset stack
                    stack->reset();

                    //write server result
                    stack->writeInt(res);

#ifdef _DEBUG
				printf("\n");
#endif
              } // end of case METHOD_sqlite_interrupt:
               break;
            case METHOD_sqlite_libversion:
               {

#ifdef _DEBUG
				printf("Net: Version ");
#endif
                   //defining output parameters
                    STACK_Str out_version=NULL;

                    // call method
                    int res = svc_sqlite_libversion(
                       
                      &out_version 
                    );

                    // reset stack
                    stack->reset();

                    //write server result
                    stack->writeInt(res);

                    // write back output parameters
                    if (res == STACK_OK)
                    {
                       stack->writeStr(out_version);
                    } 	 
#ifdef _DEBUG
				printf("\n");
#endif
              } // end of case METHOD_sqlite_libversion:
               break;
#if 0
            case METHOD_sqlite_libencoding:
               {

#ifdef _DEBUG
				printf("Net: Encoding ");
#endif
                    //defining output parameters
                    STACK_Str out_encoding=NULL;

                    // call method
                    int res = svc_sqlite_libencoding(
                       
                      &out_encoding 
                    );

                    // reset stack
                    stack->reset();

                    //write server result
                    stack->writeInt(res);

                    // write back output parameters
                    if (res == STACK_OK)
                    {
                       stack->writeStr(out_encoding);
                    } 	 
#ifdef _DEBUG
				printf("\n");
#endif
              } // end of case METHOD_sqlite_libencoding:
               break;
#endif
           default:
#ifdef _DEBUG
				printf("Net: Undefined op %d\n",Method);
#endif
				return STACK_WRONG_FORMAT_OR_TOO_BIG;
 
// extensions
		   case METHOD_sqlite_errmsg:
#ifdef _DEBUG
				printf("Get Errmsg ");
#endif
				{
				STACK_Int db = stack->readInt();
				STACK_Str ms;
				int err = svc_sqlite_errmsg(db,&ms);
				stack->reset();
				stack->writeInt(err);
				if(err==STACK_OK)
				{	stack->writeStr(ms);
				}
#ifdef _DEBUG
				printf(" msg is %s\n",ms);
#endif
				}
			   break;
#ifdef ANDROMEDA
		   case METHOD_sqlite_db_exists:
               {
#ifdef _DEBUG
				printf("Net: Exists ");
#endif
                    // read input parameters
                    STACK_Str in_filename = stack->readStr();
 
                    //defining output parameters
                    STACK_Int out_errcode=SQLITE_INTERNAL;

                    // call method
                    int res = svc_sqlite_db_exists(
                      in_filename ,
                      &out_errcode
                    );

                    // reset stack
                    stack->reset();

                    //write server result
                    stack->writeInt(res);

                    // write back output parameters
                    if (res == STACK_OK)
                    {
                       stack->writeInt(out_errcode);
                      } 	 
#ifdef _DEBUG
				printf("\n");
#endif
              } // end of case METHOD_sqlite_open:
               break;
#endif
          } // end of case
       } // end of try
       catch(...)
       {
           // something went wrong
           stack->reset();
           stack->writeInt(STACK_SERVER_STUB_ERROR);
       }
  }
  else
  {
    //message  broken. Try to send error back
    return res;
  }
  // send and return
  return stack->sendMessage(new_socket);
}

// extensions
int RequestHandler::svc_sqlite_errmsg(
				STACK_Int in_db_handle,
				STACK_Str *out_msg)
{
 PointerHolder *ph = getHolderByHandle(dbhandles,in_db_handle);
 if (ph != 0)
 {
   sqlite3* db = (sqlite3 *)ph->getPointer();
   (*out_msg) = (char *)sqlite3_errmsg(db);
   return STACK_OK;
 }
 else
  return STACK_USER_ERROR_BASE+BAD_HANDLE;
//--cg--sqlite/methods/sqlite_changes--end
}

#ifdef ANDROMEDA

int RequestHandler::svc_sqlite_db_exists(
                  STACK_Str in_filename ,
                  STACK_Int *out_errcode 
             )
{
//--cg--sqlite/methods/sqlite_open--begin
 // implement this method
 try
 {
   *out_errcode = sqlite3_DB_Exists(in_filename);
 }
 catch(...)
 {
  return STACK_SERVER_STUB_ERROR;
 }
 return STACK_OK;
//--cg--sqlite/methods/sqlite_open--end

}

#endif



